 /*
  * Filnavn: JavabokGUI.java
  * Revisjonshistorie:
  *     mai 1999: 1.utgave ble laget
  *     oktober 1999: velgFraEnkeltvalgListe() er lagt inn.
  *     oktober 2000: tastatursttte for knappene, samt dokumentasjon i hht javadoc
  *
  * Kommentar: Tastatursttten er laget slik at enter-tasten virker nr
  * knappen har fokus. Det har hittil ikke lyktes  f enter-tasten til  virke
  * som default button. Ulike metoder er prvd. Javas bug-database inneholder ogs
  * en del om dette.
  *
  * Filen inneholder mange hjelpeklasser. Det er kun klassen JavabokGUI som er
  * offentlig, og det er bare denne klassen som er dokumentert i hht javadoc.
  */
package mittBibliotek;

/**
    Versjon: Oktober 2000. E.L.

    Klassen gjr det mulig  kommunisere med brukeren via et primitivt
    grafisk brukergrensesnitt. Et alternativ til tekstbasert kommunikasjon
    via konsollet.
    <p><p>
    Tastatursttten p trykknappene virker slik at knappen m ha fokus for at
    Enter-tasten skal kunne brukes.
    <p><p>
    Se kapittel 3.3-3.5 i boka "Programmering i Java" av E. Lervik og V. B. Havdal.
    <p><p>
    Klassen inneholder et testprogram som kjres p flgende mte fra kommandolinjen:
     <p><p> <blockquote><pre>
      >java mittBibliotek/JavabokGUI
     </pre></blockquote>
     <p>
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

interface Konstanter {
  public static final Dimension strVindu = new Dimension(500, 700);
  public static final Point vinduHjrne = new Point(10, 50);
  public static final Dimension strDialog = new Dimension(200, 150);
  public static final Dimension strValgDialog = new Dimension(200, 300);
  public static final Point dialogHjrne = new Point(550, 300);
  public static final Dimension strMelding = new Dimension(240, 120);
  public static final Point meldingHjrne= new Point(550, 460);
  public static final int antRaderUtskrift = 50;
  public static final int antKolUtskrift = 50;
  public static final int antKolInputfelt = 30;
  public static final int antKolInputfeltTall = 10;
  public static final String inn = "***Inndata: ";
}

class JaNeiDialog extends JDialog implements Konstanter {
  private JPanel knappepanel = new JPanel();
  private boolean jasvar = true;
  private JLabel sprsml = new JLabel();

  public JaNeiDialog(JFrame foreldre) {
    super(foreldre, true);
    setLocation(meldingHjrne);

    Container innhold = getContentPane();
    innhold.add(sprsml, BorderLayout.CENTER);

    JButton jaKnapp = new JButton("Ja");
    jaKnapp.setMnemonic('J');
    JaLytter jaLytter = new JaLytter();
    jaKnapp.addActionListener(jaLytter);
    knappepanel.add(jaKnapp);
    JButton neiKnapp = new JButton("Nei");
    neiKnapp.setMnemonic('N');
    NeiLytter neiLytter = new NeiLytter();
    neiKnapp.addActionListener(neiLytter);
    knappepanel.add(neiKnapp);
    innhold.add(knappepanel, BorderLayout.SOUTH);
    addWindowListener(new DialogLytter());

    JPanel p = new JPanel();
    innhold.add(p, BorderLayout.NORTH);
    innhold.add(p, BorderLayout.WEST);

    KeyStroke enterTasten = KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0);
    jaKnapp.registerKeyboardAction(jaLytter, "OK", enterTasten,
           JComponent.WHEN_FOCUSED);
    neiKnapp.registerKeyboardAction(neiLytter, "OK", enterTasten,
           JComponent.WHEN_FOCUSED);
  }

  class DialogLytter extends WindowAdapter {
    public void windowClosing(WindowEvent e) {
      setVisible(false);
    }
   }

  class JaLytter implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      jasvar = true;
      setVisible(false);
    }
  }

  class NeiLytter implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      jasvar = false;
      setVisible(false);
    }
  }

  public boolean visJaNeiDialog(String tittel, String sprsmlet) {
    setTitle(tittel);
    sprsml.setText("          " + sprsmlet + "          ");
    pack();
    setVisible(true);  // ...venter...
    return jasvar;
  }
}

class ToppDialog extends JDialog implements Konstanter {
  private JButton bOK = new JButton("OK");
  private OkLytter lytteren = new OkLytter();
  private JPanel knappepanel = new JPanel();

  public ToppDialog(JFrame foreldre) {
    super(foreldre, true);
    setSize(strDialog);
    setLocation(dialogHjrne);

    bOK.addActionListener(lytteren);
    knappepanel.add(bOK);

    addWindowListener(new DialogLytter());

    /* Definerer akselerasjonstast til OK-knappen:*/
    KeyStroke enterTasten = KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0);
    finnOkKnapp().registerKeyboardAction(finnOkLytter(), "OK", enterTasten,
           JComponent.WHEN_IN_FOCUSED_WINDOW);
  }

  protected ActionListener finnOkLytter() {
    return lytteren;
  }

  protected JPanel finnKnappepanel() {
    return knappepanel;
  }

  protected JButton finnOkKnapp() {
    return bOK;
  }

  class DialogLytter extends WindowAdapter {
    public void windowClosing(WindowEvent e) {
      setVisible(false);
    }
   }

  class OkLytter implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      setVisible(false);
    }
  }
}

class Meldingsboks extends ToppDialog {
  public Meldingsboks(JFrame foreldre, String tittel, String melding) {
    super(foreldre);
    setLocation(meldingHjrne);
    setTitle(tittel);
    Container innhold = getContentPane();
    JLabel tekst = new JLabel("          " + melding + "          " );
    innhold.add(tekst, BorderLayout.CENTER);
    innhold.add(finnKnappepanel(), BorderLayout.SOUTH);
    pack();
  }

  public void visMelding() {
    setVisible(true);
  }
}

class Listeboks extends ToppDialog {
  private JLabel ledetekstfelt = new JLabel();
  private Container innhold;

  public Listeboks(JFrame foreldre) {
    super(foreldre);
    setSize(strValgDialog);
    setLocation(dialogHjrne);
    innhold = getContentPane();
    innhold.add(ledetekstfelt, BorderLayout.NORTH);
    innhold.add(finnKnappepanel(), BorderLayout.SOUTH);
  }

  boolean[] visValgliste(String tittel, String ledetekst,
      String[] valg, boolean flervalg) {
    setTitle(tittel);
    ledetekstfelt.setText("          " + ledetekst);
    JList liste = new JList(valg);
    JScrollPane rullefelt = new JScrollPane(liste);
    innhold.add(rullefelt, BorderLayout.CENTER);
    if (flervalg) liste.setSelectionMode(
          ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
    else {
      liste.setSelectionMode(
          ListSelectionModel.SINGLE_SELECTION);
      liste.setSelectedIndex(0);  // standard valg
    }
    setVisible(true);

    int antValg = valg.length;
    boolean[] resultat = new boolean[antValg];
    for (int i = 0; i < antValg; i++) resultat[i] = false;
    int[] valgteIndekser = liste.getSelectedIndices();
    for (int i = 0; i < valgteIndekser.length; i++) {
      resultat[valgteIndekser[i]] = true;
      }
    return resultat;
  }
}

class TekstInput extends ToppDialog {
  private JLabel ledetekstfelt = new JLabel();
  private JTextField inputfelt = new JTextField(antKolInputfelt);

  protected JTextField finnInputfelt() {
    return inputfelt;
  }

  public TekstInput(JFrame foreldre) {
    super(foreldre);
    Container innhold = getContentPane();
    JPanel p = new JPanel();
    p.add(ledetekstfelt);
    p.add(inputfelt);
    innhold.add(p, BorderLayout.CENTER);
    innhold.add(finnKnappepanel(), BorderLayout.SOUTH);
  }

  public String visDialog(String tittel, String ledetekst) {
    setTitle(tittel);
    ledetekstfelt.setText(ledetekst);
    inputfelt.setText("");
    pack();
    setVisible(true);  // ...venter...
    return inputfelt.getText();
  }
}

class HeltallsInput extends TekstInput {
  private JTextField inputfelt;
  private int tall;

  public HeltallsInput(JFrame foreldre) {
    super(foreldre);
    inputfelt = finnInputfelt();
    inputfelt.setColumns(antKolInputfeltTall);
    /*
     * Her burde vi ha lyttet etter inputfelt sitt tap av fokus.
     * Mtte gjre det annerledes pga en feil i en tidligere
     * utgave av JDK. Denen feilen er n rettet opp,
     * Koden her vil endres nr tiden tillater det.
     * Se ellers eksemplet side 412-413 i boka,
     * der focusLost er brukt.
     */
    JButton ok = finnOkKnapp();
    ok.addFocusListener(new Heltallskontroll());
  }

  class Heltallskontroll extends FocusAdapter {
    public void focusGained(FocusEvent hendelse) {
      if  (!hendelse.isTemporary()) {
        try {
          String resultat = inputfelt.getText();
          tall = Integer.parseInt(resultat);
        } catch (NumberFormatException exc) {
            inputfelt.setText("Ugyldig heltall");
            inputfelt.select(0, 15);
            inputfelt.requestFocus();
          }
        }
      }
  }

  public int visHeltallsdialog(String tittel, String ledetekst) {
    visDialog(tittel, ledetekst);
    return tall;
  }
}

class DesimaltallInput extends TekstInput {
  private JTextField inputfelt;
  private double tall;

  public DesimaltallInput(JFrame foreldre) {
    super(foreldre);
    inputfelt = finnInputfelt();
    inputfelt.setColumns(antKolInputfeltTall);
    inputfelt.validate();
    JButton ok = finnOkKnapp();
    /* Se kommentar i klassen HeltallsInput */
    ok.addFocusListener(new Desimaltallkontroll());
  }

  class Desimaltallkontroll extends FocusAdapter {
    public void focusGained(FocusEvent hendelse) {
    if (!hendelse.isTemporary()) {
      try {
        String resultat = inputfelt.getText();
        Double tallObjekt = new Double(resultat);
        tall = tallObjekt.doubleValue();
      } catch (NumberFormatException exc) {
          inputfelt.setText("Ugyldig desimaltall");
          inputfelt.select(0, 19);
          inputfelt.requestFocus();
        }
      }
    }
  }

  public double visDesimaltalldialog(String tittel, String ledetekst) {
    visDialog(tittel, ledetekst);
    return tall;
  }
}

public class JavabokGUI extends JFrame implements Konstanter {
  private boolean visInndata = true;  // viser tekst, tall og valg
  private JTextArea utskrift =
                 new JTextArea(antRaderUtskrift, antKolUtskrift);

  /**
     @param String tittel, tittelen i utskriftvinduet
   */
  public JavabokGUI(String tittel) {
    setTitle(tittel);
    setSize(strVindu); // bruker ikke pack()
    setLocation(vinduHjrne);

    Container innhold = getContentPane();

    JScrollPane rullefelt = new JScrollPane(utskrift);
    innhold.add(rullefelt, BorderLayout.CENTER);

    JPanel knappePanel = new JPanel();
    JButton bOK = new JButton("Ok");
    knappePanel.add(bOK);
    bOK.addActionListener(new OkLytter());

    innhold.add(knappePanel, BorderLayout.SOUTH);
    addWindowListener(new VindusLytter());
  }

  class VindusLytter extends WindowAdapter {
    public void windowClosing(WindowEvent e) {
      System.exit(0);
    }
  }

  class OkLytter implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      System.exit(0);
    }
  }

  /**
     Metoden brukes til  sl av eller p logging av inndata.
     Dersom logging er p, vil alle inndata skrives i utskriftvinduet.
     Standard er at dette gjres, men av og til blir dette s mye data,
     at vinduet fylles helt opp. Da kan det vre aktuelt  sl av dette.
     @param String boolean visInndataVerdi
  */
  public void settVisInndata(boolean visInndataVerdi) {
    visInndata = visInndataVerdi;
  }

  /**
     Metoden skriver en tekst i en meldingsboks med en OK-knapp.
     @param String tittel, tittelen verst i boksen
     @param String melding, teksten som skrives ut
  */
  public void skrivMelding(String tittel, String melding) {
    Meldingsboks m = new Meldingsboks(this, tittel, melding);
    m.visMelding();
  }

  /**
     Metoden leser en linje tekst fra brukeren.
     @param String tittel, tittelen verst i dialogboksen
     @param String ledetekst
     @return Teksten som brukeren har skrevet inn.
  */
  public String lesTekst(String tittel, String ledetekst) {
    TekstInput tekst = new TekstInput(this);
    String resultat = tekst.visDialog(tittel, ledetekst);
    if (visInndata) {
      utskrift.append(inn + ledetekst + " " + resultat + "\n");
    }
    return resultat;
  }

  /**
     Metoden leser et heltall fra brukeren.
     Dersom det brukeren skriver inn ikke kan tolkes som et heltall,
     skrives meldingen "Ugyldig heltall" i inputfeltet, og brukeren
     m skrive inn tallet p nytt.
     @param String tittel, tittelen verst i dialogboksen
     @param String ledetekst
     @return Tallet som brukeren har skrevet inn.
  */
  public int lesHeltall(String tittel, String ledetekst) {
    HeltallsInput tallfelt = new HeltallsInput(this);
    int resultat = tallfelt.visHeltallsdialog(tittel, ledetekst);
    if (visInndata) {
      utskrift.append(inn + ledetekst + " " + resultat + "\n");
    }
    return resultat;
  }

  /**
     Metoden leser et desimalltall fra brukeren.
     Dersom det brukeren skriver inn ikke kan tolkes som et desimaltall,
     skrives meldingen "Ugyldig desimaltall" i inputfeltet, og brukeren
     m skrive inn tallet p nytt.
     @param String tittel, tittelen verst i dialogboksen
     @param String ledetekst
     @return Tallet som brukeren har skrevet inn.
  */
  public double lesDesimaltall(String tittel, String ledetekst) {
    DesimaltallInput tallfelt = new DesimaltallInput(this);
    double resultat = tallfelt.visDesimaltalldialog(tittel, ledetekst);
    if (visInndata) {
      utskrift.append(inn + ledetekst + " " + resultat + "\n");
    }
    return resultat;
  }

  /**
     Metoden viser en meldingsboks med en ja-knapp og en nei-knapp.
     @param String tittel, tittelen verst i dialogboksen
     @param String sprsml
     @return true dersom brukeren har trykket p ja-knappen, false ellers.
  */
  public boolean jaSvar(String tittel, String sprsml) {
    JaNeiDialog jaNei = new JaNeiDialog(this);
    boolean posSvar = jaNei.visJaNeiDialog(tittel, sprsml);
    if (visInndata) {
      utskrift.append(inn + "Sprsml: " + sprsml + " Svar: ");
      if (posSvar) utskrift.append("Ja.\n");
      else utskrift.append("Nei.\n");
    }
    return posSvar;
  }

  /**
     Metoden presenterer en listeboks for brukeren. Brukeren kan velge flere alternativer.
     Brukeren kan la vre  velge noe i det hele tatt.
     Flere enkeltvalg gjres ved  bruke CTRL+mus,
     intervaller velges ved  bruke SHIFT+mus.
     Eksempel p bruk:
     <p> <blockquote><pre>
          String[] valg = {"Bergen", "Trondheim", "Oslo", "lesund", "Troms", "Arendal", "Hamar"};
          boolean[] resultat = gui.velgFraFlervalgListe("Valg", "Velg flere byer:", valg);
     </pre></blockquote>
     Dersom brukeren har valgt Trondheim og lesund vil resultat[1] og resultat[3]
     ha verdien true, mens de vrige elementene i tabellen resultat har verdien false.
     @param String tittel, tittelen verst i dialogen
     @param String ledetekst, teksten over listeboksen
     @return String[] valg, de valgene som skal vises i listeboksen
     @return En tabell med logiske verdier, Tabellen er parallell med tabellen valg.
  */
  public boolean[] velgFraFlervalgListe(String tittel, String ledetekst,
      String[] valg) {
    Listeboks liste = new Listeboks(this);
    boolean[] resultat =
      liste.visValgliste(tittel, ledetekst, valg, true);
    if (visInndata) {
      utskrift.append(inn + "Flgende er valgt:");
      for (int i = 0; i < resultat.length; i++) {
        if (resultat[i]) utskrift.append(" " + valg[i]);
      }
      utskrift.append("\n");
    }
    return resultat;
  }

  /**
     Metoden presenterer en listeboks for brukeren. Brukeren m velge ett alternativ.
     Eksempel p bruk:
     <p> <blockquote><pre>
          String[] valg = {"Bergen", "Trondheim", "Oslo", "lesund", "Troms", "Arendal", "Hamar"};
          int valgIndeks = gui.velgFraEnkeltvalgListe("Valg", "Velg en by:", valg);
     </pre></blockquote>
     Dersom brukeren velger Trondheim vil valgIndeks ha verdien 1.

     @param String tittel, tittelen verst i dialogen
     @param String ledetekst, teksten over listeboksen
     @return String[] valg, de valgene som skal vises i listeboksen
     @return Indeksen til valget.
  */
  public int velgFraEnkeltvalgListe(String tittel, String ledetekst,
      String[] valg) {
    Listeboks liste = new Listeboks(this);
    boolean[] resultat =
      liste.visValgliste(tittel, ledetekst, valg, false);
    int indeks = 0; // indeks 0 er standardvalget
    while (indeks < resultat.length && !resultat[indeks]) indeks++;
    if (visInndata) {
       utskrift.append(inn + "Flgende er valgt: " + valg[indeks] + "\n");
    }
    return indeks;   // RETUR
  }

  /**
     Metoden skriver en tekst, etterfulgt av linjeskift, i utskriftvinduet.
     @param String tekst
  */
  public void skrivResultater(String tekst) {
    utskrift.append(tekst + "\n");
  }

  public static void main(String[] args) {
    JavabokGUI gui = new JavabokGUI("Et testprogram....");
    gui.show();

    gui.skrivMelding("Tester skrivMelding()", "Dette er et testprogram");

    String tekst = gui.lesTekst("Tester lesTekst()", "Skriv en tekst: ");

    int tall = gui.lesHeltall("Tester lesHeltall()", "Skriv heltall: ");

    double tall2 = gui.lesDesimaltall("Tester lesDesimaltall()",
                         "Skriv desimaltall: ");

    if(gui.jaSvar("Tester ja/nei-boks.", "Trykk: ")) {
      gui.skrivResultater("Du trykket JA");
      }
    else gui.skrivResultater("\nDu trykket NEI");
    if(gui.jaSvar("Tester ja/nei-boks.",
        "N kan du trykke p den andre knappen: ")) {
      gui.skrivResultater("\nDu trykket JA");
    }
    else  gui.skrivResultater("\nDu trykket NEI");

    String[] valg = {"Bergen", "Trondheim", "Oslo", "lesund",
                     "Troms", "Arendal", "Hamar"};
    boolean[] resultat =
            gui.velgFraFlervalgListe("Valg", "Velg flere byer:", valg);
    int valgIndeks =
            gui.velgFraEnkeltvalgListe("Valg", "Velg en by:", valg);
  }
}