/*
 * MittTallformatUt.java   E.L. 2000-01-31
 *
 * Klassen beskriver et desimalformat som egner seg til utskrift av tall
 * under hverandre i kolonner. Antall posisjoner fr og etter desimalkomma er parametre
 * i konstruktren.
 */
package mittBibliotek;

import java.text.*;
import java.util.*;

public class MittTallformatUt {
  private DecimalFormat tallformat;

  public MittTallformatUt(int antPosFrKomma, int antPosEtterKomma) {
    char[] formatTegn = new char[antPosFrKomma + antPosEtterKomma + 1];
    Arrays.fill(formatTegn, '0');
    formatTegn[antPosFrKomma] = '.';
    tallformat = new DecimalFormat(new String(formatTegn));
  }

  public String format(double tall) { // kan ogs sende inn heltall som argument
    boolean fortegn = false;
    if (tall < 0) {  // Vi setter p fortegnet til slutt
      fortegn = true;
      tall = -tall;
    }

    String tekst = tallformat.format(tall);

    /* Bytter ut ledende nuller med blanke, men ikke siste foran komma */
    char[] tegnene = tekst.toCharArray();
    int pos = 0;
    while (pos < tegnene.length && tegnene[pos] == '0') {
      if (tegnene[pos + 1] != ',') tegnene[pos] = ' ';
      pos++;
    }

    String nyttFormat = new String(tegnene);
    if (fortegn) {
      if (pos > 0) {
        tegnene[pos - 1] = '-';
        nyttFormat = new String(tegnene);
      } else nyttFormat = "-" + nyttFormat;
    }
    return nyttFormat;
  }
}